#!/usr/bin/python
#Stride Web service

def _toParameters(queryData):
    if len(queryData)!=1:
        raise Exception, "A single PDB object/file is needed"
        
    datum=queryData[0]
    
    from bioMoby import MobyObject
    import random, urllib

    commandName="/usr/local/bin/stride"

    parameters=[]
    tempfiles=[]


    tfs='tmp'+ `int(random.random()*1000000)`

    u=urllib.urlopen("http://www.rcsb.org/pdb/cgi/export.cgi/"+datum.id+"?format=PDB&pdbId="+datum.id+"&compression=None")
    s=u.read()
    if len(s)==0:
        raise Exception, "PDB ID unknown"
        
    f=file(tfs,"w")
    f.write(s)
    u.close()
    f.close()

    parameters.append("-f "+tfs)
    tempfiles.append(tfs)
    
    return (commandName, "".join(parameters), tempfiles)

def _strideFormatter(results):
    from bioMoby import MobyTextFormatted, MobyString
    
    reslines=results.split("\n")

    d={}
    
    for l in reslines:
        cols=l.split()
	
	if len(cols)>1 and cols[0]=='ASG':
	    if cols[2] not in d.keys():
		d[cols[2]]=[]
		
	    d[cols[2]].append(cols[5])
	
    aCollection=[]
    
    for key in d.keys():
	aCollection.append(MobyString(id=key, content="".join(d[key])))
    
    return [MobyTextFormatted(content=results), ('StrideAssignment' ,aCollection)]    

def Stride(mobyContent):
    """Dispatch the contents into several a pool of invocators
    """
    from bioMoby import Dispatcher, LocalInvocator
    
    d=Dispatcher(mobyContent, LocalInvocator, _toParameters, formatter=_strideFormatter)
    
    return d.execute()


from ZSI import dispatch
from bioMoby.webservice import TCBioMoby
dispatch.AsCGI(typesmodule=TCBioMoby)
